Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -5939,55 +5798,45 @@
     /////////////////
     case CAS_UPT_LOCK:  // try to register the transaction in UPT
-      // and write data in cache if successful registration
-      // releases locks to retry later if UPT full
-    {
-      if(r_alloc_upt_fsm.read() == ALLOC_UPT_CAS)
-      {
-        bool        wok        = false;
-        size_t      index      = 0;
-        size_t      srcid      = m_cmd_cas_srcid_fifo.read();
-        size_t      trdid      = m_cmd_cas_trdid_fifo.read();
-        size_t      pktid      = m_cmd_cas_pktid_fifo.read();
-        addr_t      nline      = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        size_t      nb_copies  = r_cas_count.read();
-
-        wok = m_upt.set(true,    // it's an update transaction
-                        false,   // it's not a broadcast
-                        true,    // response required  
-                        false,   // no acknowledge required
-                        srcid,
-                        trdid,
-                        pktid,
-                        nline,
-                        nb_copies,
-                        index);
-        if(wok)   // coherence transaction registered in UPT
-        {
-          // cache update
-          size_t way  = r_cas_way.read();
-          size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
-          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-
-          m_cache_data.write(way, set, word, r_cas_wdata.read());
-          if(r_cas_cpt.read() ==4)
-            m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
-
-          r_cas_upt_index = index;
-          r_cas_fsm = CAS_UPT_HEAP_LOCK;
-
-          // monitor
-          if(m_monitor_ok)
-          {
-            addr_t address = m_cmd_cas_addr_fifo.read();
-            check_monitor( address, r_cas_wdata.read(), false);
-
-            if(r_cas_cpt.read() ==4)
-              check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-          }
-        }
-        else       //  releases the locks protecting UPT and DIR UPT full
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
+                        // and write data in cache if successful registration
+                        // releases locks to retry later if UPT full
+    {
+        if(r_alloc_upt_fsm.read() == ALLOC_UPT_CAS)
+        {
+            bool        wok        = false;
+            size_t      index      = 0;
+            size_t      srcid      = m_cmd_cas_srcid_fifo.read();
+            size_t      trdid      = m_cmd_cas_trdid_fifo.read();
+            size_t      pktid      = m_cmd_cas_pktid_fifo.read();
+            addr_t      nline      = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
+            size_t      nb_copies  = r_cas_count.read();
+
+            wok = m_upt.set( true,    // it's an update transaction
+                             false,   // it's not a broadcast
+                             true,    // response required  
+                             false,   // no acknowledge required
+                             srcid,
+                             trdid,
+                             pktid,
+                             nline,
+                             nb_copies,
+                             index);
+            if(wok)   // coherence transaction registered in UPT
+            {
+                // cache update
+                size_t way  = r_cas_way.read();
+                size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
+                size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
+
+                m_cache_data.write(way, set, word, r_cas_wdata.read());
+                if(r_cas_cpt.read() ==4)
+                    m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
+
+                r_cas_upt_index = index;
+                r_cas_fsm = CAS_UPT_HEAP_LOCK;
+            }
+            else       //  releases the locks protecting UPT and DIR UPT full
+            {
+                r_cas_fsm = CAS_WAIT;
+            }
 
 #if DEBUG_MEMC_CAS
@@ -5996,13 +5845,9 @@
           << " CAS_UPT_LOCK> Register multi-update transaction in UPT"
           << " / wok = " << wok
-          << " / nline  = " << std::hex << nline
+          << " / address  = " << std::hex << nline*m_words*4
           << " / count = " << nb_copies << std::endl;
 #endif
-        m_cpt_cas_fsm_n_upt_lock++;
-      }
-
-      m_cpt_cas_fsm_upt_lock++;
-
-      break;
+        }
+        break;
     }
     /////////////
@@ -6011,14 +5856,11 @@
 
 #if DEBUG_MEMC_CAS
-      if(m_debug)
-      {
-        std::cout << "  <MEMC " << name()
-                  << " CAS_WAIT> Release all locks" << std::endl;
-      }
-#endif
-      r_cas_fsm = CAS_DIR_REQ;
-      break;
-    }
-    //////////////////
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_WAIT> Release all locks" << std::endl;
+#endif
+        r_cas_fsm = CAS_DIR_REQ;
+        break;
+    }
+    //////////////////////
     case CAS_UPT_HEAP_LOCK:  // lock the heap
     {
@@ -6070,7 +5912,4 @@
         cas_to_cc_send_fifo_inst    = r_cas_copy_inst.read();
         cas_to_cc_send_fifo_srcid   = r_cas_copy.read();
-#if L1_MULTI_CACHE
-        cas_to_cc_send_fifo_cache_id= r_cas_copy_cache.read();
-#endif
         if(r_cas_count.read() == 1)  // one single copy
         {
@@ -6107,7 +5946,4 @@
       HeapEntry entry = m_heap.read(r_cas_ptr.read());
       cas_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-      cas_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
       cas_to_cc_send_fifo_inst     = entry.owner.inst;
       cas_to_cc_send_fifo_put = true;
@@ -6139,138 +5975,109 @@
     }
     /////////////////////
-    case CAS_BC_TRT_LOCK:      // check the TRT to register a PUT transaction
-    {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
-      {
-        if(!r_cas_to_ixr_cmd_req)    // we can transfer the request to IXR_CMD FSM
-        {
-          // fill the data buffer
-          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-          for(size_t i = 0; i<m_words; i++)
-          {
-            if(i == word)
+    case CAS_BC_TRT_LOCK:      // get TRT lock to check TRT not full 
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_BC_TRT_LOCK state: Bas DIR allocation");
+
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
+        {
+            size_t wok_index = 0;
+            bool   wok       = !m_trt.full(wok_index);
+            if( wok )
             {
-              r_cas_to_ixr_cmd_data[i] = r_cas_wdata.read();
-            }
-            else if((i == word+1) and (r_cas_cpt.read() == 4))   // 64 bit CAS
-            {
-              r_cas_to_ixr_cmd_data[i] = m_cmd_cas_wdata_fifo.read();
+                r_cas_trt_index = wok_index;
+                r_cas_fsm       = CAS_BC_IVT_LOCK;
             }
             else
             {
-              r_cas_to_ixr_cmd_data[i] = r_cas_data[i].read();
+                r_cas_fsm       = CAS_WAIT;
             }
-          }
-          size_t wok_index = 0;
-          bool   wok       = !m_trt.full(wok_index);
-          if(wok)
-          {
-            r_cas_trt_index = wok_index;
-            r_cas_fsm       = CAS_BC_IVT_LOCK;
-          }
-          else
-          {
-            r_cas_fsm       = CAS_WAIT;
-          }
-        }
-        else
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
-        m_cpt_cas_fsm_n_trt_lock++;
-      }
-
-      m_cpt_cas_fsm_trt_lock++;
-
-      break;
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_BC_TRT_LOCK> Check TRT"
+          << " : wok = " << wok << " / index = " << wok_index << std::endl;
+#endif
+        }
+        break;
     }
     /////////////////////
-    case CAS_BC_IVT_LOCK:  // register a broadcast inval transaction in IVT
-                           // write data in cache in case of successful registration
-    {
-      if(r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS)
-      {
-        bool        wok       = false;
-        size_t      index     = 0;
-        size_t      srcid     = m_cmd_cas_srcid_fifo.read();
-        size_t      trdid     = m_cmd_cas_trdid_fifo.read();
-        size_t      pktid     = m_cmd_cas_pktid_fifo.read();
-        addr_t      nline     = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        size_t      nb_copies = r_cas_count.read();
-
-        // register a broadcast inval transaction in IVT
-        wok = m_ivt.set(false,  // it's an inval transaction
-                        true,   // it's a broadcast
-                        true,   // response required
-                        false,  // no acknowledge required
-                        srcid,
-                        trdid,
-                        pktid,
-                        nline,
-                        nb_copies,
-                        index);
-
-        if(wok)     // IVT not full
-        {
-          // cache update
-          size_t way  = r_cas_way.read();
-          size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
-          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-
-          m_cache_data.write(way, set, word, r_cas_wdata.read());
-          if(r_cas_cpt.read() ==4)
-            m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
-
-          // monitor
-          if(m_monitor_ok)
-          {
-            addr_t address = m_cmd_cas_addr_fifo.read();
-            check_monitor( address, r_cas_wdata.read(), false);
-
-            if(r_cas_cpt.read() ==4)
-              check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-          }
-          r_cas_upt_index = index;
-          r_cas_fsm = CAS_BC_DIR_INVAL;
-
+    case CAS_BC_IVT_LOCK:  // get IVT lock and register BC transaction in IVT
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_BC_IVT_LOCK state: Bas DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+        "MEMC ERROR in CAS_BC_IVT_LOCK state: Bas TRT allocation");
+
+        if( r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS )
+        {
+            // register broadcast inval transaction in IVT
+            bool        wok       = false;
+            size_t      index     = 0;
+            size_t      srcid     = m_cmd_cas_srcid_fifo.read();
+            size_t      trdid     = m_cmd_cas_trdid_fifo.read();
+            size_t      pktid     = m_cmd_cas_pktid_fifo.read();
+            addr_t      nline     = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
+            size_t      nb_copies = r_cas_count.read();
+
+            wok = m_ivt.set( false,  // it's an inval transaction
+                             true,   // it's a broadcast
+                             true,   // response required
+                             false,  // no acknowledge required
+                             srcid,
+                             trdid,
+                             pktid,
+                             nline,
+                             nb_copies,
+                             index);
 #if DEBUG_MEMC_CAS
-if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " CAS_BC_IVT_LOCK> Register a broadcast inval transaction in IVT"
-          << " / nline = " << std::hex << nline
-          << " / count = " << std::dec << nb_copies
-          << " / ivt_index = " << index << std::endl;
-#endif
-        }
-        else      //  releases the lock protecting IVT
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
-        m_cpt_cas_fsm_n_upt_lock++;
-      }
-
-      m_cpt_cas_fsm_upt_lock++;
-
-      break;
+if( m_debug and wok )
+std::cout << "  <MEMC " << name() << " CAS_BC_IVT_LOCK> Register broadcast inval in IVT"
+          << " / copies = " << r_cas_count.read() << std::endl;
+#endif
+            r_cas_upt_index = index;
+            if( wok ) r_cas_fsm = CAS_BC_DIR_INVAL;   
+            else      r_cas_fsm = CAS_WAIT;
+        }
+        break;
     }
     //////////////////////
-    case CAS_BC_DIR_INVAL:  // Register the PUT transaction in TRT, and inval the DIR entry
-    {
-      if((r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
-         (r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS) and
-         (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS))
-      {
+    case CAS_BC_DIR_INVAL:  // Register PUT transaction in TRT, 
+                            // and inval the DIR entry
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad TRT allocation");
+
+        assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad IVT allocation");
+
         // set TRT
-        m_trt.set(r_cas_trt_index.read(),
-                              false,    // PUT request to XRAM
-                              m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())],
-                              0,
-                              0,
-                              0,
-                              false,    // not a processor read
-                              0,
-                              0,
-                              std::vector<be_t> (m_words,0),
-                              std::vector<data_t> (m_words,0));
+        std::vector<data_t> data_vector;
+        data_vector.clear();
+        size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
+        for(size_t i=0; i<m_words; i++)
+        {
+            if(i == word)                                        // first modified word
+                data_vector.push_back( r_cas_wdata.read() );     
+            else if((i == word+1) and (r_cas_cpt.read() == 4))   // second modified word
+                data_vector.push_back( m_cmd_cas_wdata_fifo.read() );
+            else                                                 // unmodified words
+                data_vector.push_back( r_cas_data[i].read() );
+        }
+        m_trt.set( r_cas_trt_index.read(),
+                   false,    // PUT request 
+                   m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())],
+                   0,
+                   0,
+                   0,
+                   false,    // not a processor read
+                   0,
+                   0,
+                   std::vector<be_t> (m_words,0),
+                   data_vector );
 
         // invalidate directory entry
@@ -6278,16 +6085,14 @@
         entry.valid         = false;
         entry.dirty         = false;
-        entry.tag         = 0;
+        entry.tag           = 0;
         entry.is_cnt        = false;
         entry.lock          = false;
         entry.count         = 0;
         entry.owner.srcid   = 0;
-#if L1_MULTI_CACHE
-        entry.owner.cache_id= 0;
-#endif
         entry.owner.inst    = false;
         entry.ptr           = 0;
         size_t set          = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
         size_t way          = r_cas_way.read();
+
         m_cache_directory.write(set, way, entry);
 
@@ -6296,45 +6101,43 @@
 #if DEBUG_MEMC_CAS
 if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " CAS_BC_DIR_INVAL> Register the PUT in TRT and invalidate DIR entry"
-          << " / nline = " << std::hex << m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())]
-          << " / set = " << std::dec << set << " / way = " << way << std::endl;
-#endif
-      }
-      else
-      {
-        assert(false and "LOCK ERROR in CAS_FSM, STATE = CAS_BC_DIR_INVAL");
-      }
-      break;
+std::cout << "  <MEMC " << name() << " CAS_BC_DIR_INVAL> Inval DIR & register in TRT:"
+          << " address = " << m_cmd_cas_addr_fifo.read() << std::endl;
+#endif
+        break;
     }
     ///////////////////
     case CAS_BC_CC_SEND:  // Request the broadcast inval to CC_SEND FSM
     {
-      if(!r_cas_to_cc_send_multi_req.read() and
-          !r_cas_to_cc_send_brdcast_req.read())
-      {
-        r_cas_to_cc_send_multi_req    = false;
-        r_cas_to_cc_send_brdcast_req  = true;
-        r_cas_to_cc_send_trdid        = r_cas_upt_index.read();
-        r_cas_to_cc_send_nline        = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        r_cas_to_cc_send_index        = 0;
-        r_cas_to_cc_send_wdata        = 0;
-
-        r_cas_fsm = CAS_BC_XRAM_REQ;
-      }
-      break;
+        if( not r_cas_to_cc_send_multi_req.read() and
+            not r_cas_to_cc_send_brdcast_req.read() )
+        {
+            r_cas_to_cc_send_multi_req    = false;
+            r_cas_to_cc_send_brdcast_req  = true;
+            r_cas_to_cc_send_trdid        = r_cas_upt_index.read();
+            r_cas_to_cc_send_nline        = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
+            r_cas_to_cc_send_index        = 0;
+            r_cas_to_cc_send_wdata        = 0;
+
+            r_cas_fsm = CAS_BC_XRAM_REQ;
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CAS_BC_CC_SEND> Post a broadcast request to CC_SEND FSM" << std::endl;
+#endif
+        }
+        break;
     }
     ////////////////////
-    case CAS_BC_XRAM_REQ: // request the IXR FSM to start a put transaction
-    {
-      if(!r_cas_to_ixr_cmd_req)
-      {
-        r_cas_to_ixr_cmd_req     = true;
-        r_cas_to_ixr_cmd_write   = true;
-        r_cas_to_ixr_cmd_nline   = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        r_cas_to_ixr_cmd_trdid   = r_cas_trt_index.read();
-        r_cas_fsm                = CAS_IDLE;
-        cmd_cas_fifo_get         = true;
-        r_cas_cpt                = 0;
+    case CAS_BC_XRAM_REQ: // request the IXR FSM to start a PUT transaction
+    {
+        if( not r_cas_to_ixr_cmd_req.read() )
+        {
+            r_cas_to_ixr_cmd_req     = true;
+            r_cas_to_ixr_cmd_put     = true;
+            r_cas_to_ixr_cmd_index   = r_cas_trt_index.read();
+            r_cas_fsm                = CAS_IDLE;
+            cmd_cas_fifo_get         = true;
+            r_cas_cpt                = 0;
 
 #if DEBUG_MEMC_CAS
@@ -6342,28 +6145,23 @@
 std::cout << "  <MEMC " << name()
           << " CAS_BC_XRAM_REQ> Request a PUT transaction to IXR_CMD FSM" << std::hex
-          << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
+          << " / address = " << (addr_t) m_cmd_cas_addr_fifo.read()
           << " / trt_index = " << r_cas_trt_index.read() << std::endl;
 #endif
-      }
-      else
-      {
-        std::cout << "ERROR in MEM_CACHE / CAS_BC_XRAM_REQ state"
-                  << " : request should not have been previously set" << std::endl;
-      }
-      break;
+        }
+        break;
     }
     /////////////////
     case CAS_RSP_FAIL:  // request TGT_RSP FSM to send a failure response
     {
-      if(!r_cas_to_tgt_rsp_req)
-      {
-        cmd_cas_fifo_get     = true;
-        r_cas_cpt              = 0;
-        r_cas_to_tgt_rsp_req = true;
-        r_cas_to_tgt_rsp_data  = 1;
-        r_cas_to_tgt_rsp_srcid = m_cmd_cas_srcid_fifo.read();
-        r_cas_to_tgt_rsp_trdid = m_cmd_cas_trdid_fifo.read();
-        r_cas_to_tgt_rsp_pktid = m_cmd_cas_pktid_fifo.read();
-        r_cas_fsm              = CAS_IDLE;
+        if( not r_cas_to_tgt_rsp_req.read() )
+        {
+            cmd_cas_fifo_get       = true;
+            r_cas_cpt              = 0;
+            r_cas_to_tgt_rsp_req   = true;
+            r_cas_to_tgt_rsp_data  = 1;
+            r_cas_to_tgt_rsp_srcid = m_cmd_cas_srcid_fifo.read();
+            r_cas_to_tgt_rsp_trdid = m_cmd_cas_trdid_fifo.read();
+            r_cas_to_tgt_rsp_pktid = m_cmd_cas_pktid_fifo.read();
+            r_cas_fsm              = CAS_IDLE;
 
 #if DEBUG_MEMC_CAS
@@ -6372,20 +6170,20 @@
           << " CAS_RSP_FAIL> Request TGT_RSP to send a failure response" << std::endl;
 #endif
-      }
-      break;
+        }
+        break;
     }
     ////////////////////
     case CAS_RSP_SUCCESS:  // request TGT_RSP FSM to send a success response
     {
-      if(!r_cas_to_tgt_rsp_req)
-      {
-        cmd_cas_fifo_get       = true;
-        r_cas_cpt              = 0;
-        r_cas_to_tgt_rsp_req = true;
-        r_cas_to_tgt_rsp_data  = 0;
-        r_cas_to_tgt_rsp_srcid = m_cmd_cas_srcid_fifo.read();
-        r_cas_to_tgt_rsp_trdid = m_cmd_cas_trdid_fifo.read();
-        r_cas_to_tgt_rsp_pktid = m_cmd_cas_pktid_fifo.read();
-        r_cas_fsm              = CAS_IDLE;
+        if( not r_cas_to_tgt_rsp_req.read() )
+        {
+            cmd_cas_fifo_get       = true;
+            r_cas_cpt              = 0;
+            r_cas_to_tgt_rsp_req   = true;
+            r_cas_to_tgt_rsp_data  = 0;
+            r_cas_to_tgt_rsp_srcid = m_cmd_cas_srcid_fifo.read();
+            r_cas_to_tgt_rsp_trdid = m_cmd_cas_trdid_fifo.read();
+            r_cas_to_tgt_rsp_pktid = m_cmd_cas_pktid_fifo.read();
+            r_cas_fsm              = CAS_IDLE;
 
 #if DEBUG_MEMC_CAS
@@ -6394,51 +6192,46 @@
           << " CAS_RSP_SUCCESS> Request TGT_RSP to send a success response" << std::endl;
 #endif
-      }
-      break;
-    }
-    /////////////////////
+        }
+        break;
+    }
+    ///////////////////////
     case CAS_MISS_TRT_LOCK:         // cache miss : request access to transaction Table
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
-      {
-        size_t   index = 0;
-        bool hit_read = m_trt.hit_read(
-                          m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],index);
-        bool hit_write = m_trt.hit_write(
-                           m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]);
-        bool wok = !m_trt.full(index);
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
+        {
+            size_t   index = 0;
+            bool hit_read  = m_trt.hit_read(
+                             m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],index);
+            bool hit_write = m_trt.hit_write(
+                             m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]);
+            bool wok       = not m_trt.full(index);
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_LOCK> Check TRT state"
-                    << " / hit_read = "  << hit_read
-                    << " / hit_write = " << hit_write
-                    << " / wok = " << wok
-                    << " / index = " << index << std::endl;
-        }
-#endif
-
-        if(hit_read or !wok or hit_write)    // missing line already requested or no space in TRT
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
-        else
-        {
-          r_cas_trt_index = index;
-          r_cas_fsm       = CAS_MISS_TRT_SET;
-        }
-        m_cpt_cas_fsm_n_trt_lock++;
-      }
-
-      m_cpt_cas_fsm_trt_lock++;
-
-      break;
-    }
-    ////////////////////
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_LOCK> Check TRT state"
+          << " / hit_read = "  << hit_read
+          << " / hit_write = " << hit_write
+          << " / wok = " << wok
+          << " / index = " << index << std::endl;
+#endif
+
+            if(hit_read or !wok or hit_write)    // missing line already requested or TRT full
+            {
+                r_cas_fsm = CAS_WAIT;
+            }
+            else
+            {
+                r_cas_trt_index = index;
+                r_cas_fsm       = CAS_MISS_TRT_SET;
+            }
+        }
+        break;
+    }
+    //////////////////////
     case CAS_MISS_TRT_SET: // register the GET transaction in TRT
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
-      {
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+        "MEMC ERROR in CAS_MISS_TRT_SET state: Bad TRT allocation");
+
         std::vector<be_t> be_vector;
         std::vector<data_t> data_vector;
@@ -6451,49 +6244,44 @@
         }
 
-        m_trt.set(r_cas_trt_index.read(),
-                              true,   // read request
-                              m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],
-                              m_cmd_cas_srcid_fifo.read(),
-                              m_cmd_cas_trdid_fifo.read(),
-                              m_cmd_cas_pktid_fifo.read(),
-                              false,    // write request from processor
-                              0,
-                              0,
-                              be_vector,
-                              data_vector);
+        m_trt.set( r_cas_trt_index.read(),
+                   true,     // GET 
+                   m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],
+                   m_cmd_cas_srcid_fifo.read(),
+                   m_cmd_cas_trdid_fifo.read(),
+                   m_cmd_cas_pktid_fifo.read(),
+                   false,    // write request from processor
+                   0,
+                   0,
+                   std::vector<be_t>(m_words,0),                         
+                   std::vector<data_t>(m_words,0) );                         
+
         r_cas_fsm = CAS_MISS_XRAM_REQ;
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_SET> Register a GET transaction in TRT" << std::hex
-                    << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
-                    << " / trt_index = " << r_cas_trt_index.read() << std::endl;
-        }
-#endif
-      }
-      break;
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_SET> Register GET transaction in TRT" 
+          << " / address = " << std::hex << (addr_t)m_cmd_cas_addr_fifo.read()
+          << " / trt_index = " << std::dec << r_cas_trt_index.read() << std::endl;
+#endif
+        break;
     }
     //////////////////////
-    case CAS_MISS_XRAM_REQ:  // request the IXR_CMD FSM to fetch the missing line
-    {
-      if(!r_cas_to_ixr_cmd_req)
-      {
-        r_cas_to_ixr_cmd_req        = true;
-        r_cas_to_ixr_cmd_write      = false;
-        r_cas_to_ixr_cmd_trdid      = r_cas_trt_index.read();
-        r_cas_to_ixr_cmd_nline      = m_nline[(addr_t) m_cmd_cas_addr_fifo.read()];
-        r_cas_fsm                   = CAS_WAIT;
+    case CAS_MISS_XRAM_REQ:  // request the IXR_CMD FSM a GET request
+    {
+        if( not r_cas_to_ixr_cmd_req.read() )
+        {
+            r_cas_to_ixr_cmd_req        = true;
+            r_cas_to_ixr_cmd_put        = false;
+            r_cas_to_ixr_cmd_index      = r_cas_trt_index.read();
+            r_cas_fsm                   = CAS_WAIT;
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_MISS_XRAM_REQ> Request a GET transaction to IXR_CMD FSM" << std::hex
-                    << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
-                    << " / trt_index = " << r_cas_trt_index.read() << std::endl;
-        }
-#endif
-      }
-      break;
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_MISS_XRAM_REQ> Request a GET transaction"
+          << " / address = " << std::hex << (addr_t) m_cmd_cas_addr_fifo.read()
+          << " / trt_index = " << std::dec << r_cas_trt_index.read() << std::endl;
+#endif
+        }
+        break;
     }
   } // end switch r_cas_fsm
@@ -6528,4 +6316,6 @@
   ///////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "cc_send_fsm" << std::endl;
+
   switch(r_cc_send_fsm.read())
   {
@@ -6928,11 +6718,11 @@
 if(m_debug)
 std::cout << "  <MEMC " << name()
-          << " CC_SEND_WRITE_UPDT_NLINE> Multicast-Update for line "
-          << r_write_to_cc_send_nline.read() << std::endl;
+          << " CC_SEND_WRITE_UPDT_NLINE> Multicast-Update for address "
+          << r_write_to_cc_send_nline.read()*m_words*4 << std::endl;
 #endif
         break;
       }
       /////////////////////////////
-      case CC_SEND_WRITE_UPDT_DATA:   // send N data flits for a multi-update (from WRITE FSM)
+      case CC_SEND_WRITE_UPDT_DATA:   // send data flits for multi-update (from WRITE FSM)
       {
         if(not p_dspin_m2p.read) break;
@@ -6966,6 +6756,6 @@
 if(m_debug)
 std::cout << "  <MEMC " << name()
-          << " CC_SEND_CAS_BRDCAST_NLINE> Broadcast-Inval for line "
-          << r_cas_to_cc_send_nline.read() << std::endl;
+          << " CC_SEND_CAS_BRDCAST_NLINE> Broadcast-Inval for address: "
+          << r_cas_to_cc_send_nline.read()*m_words*4 << std::endl;
 #endif
         break;
@@ -7004,6 +6794,6 @@
 if(m_debug)
 std::cout << "  <MEMC " << name()
-          << " CC_SEND_CAS_UPDT_NLINE> Multicast-Update for line "
-          << r_cas_to_cc_send_nline.read() << std::endl;
+          << " CC_SEND_CAS_UPDT_NLINE> Multicast-Update for address "
+          << r_cas_to_cc_send_nline.read()*m_words*4 << std::endl;
 #endif
         break;
@@ -7025,5 +6815,5 @@
       }
       ////////////////////////////////
-      case CC_SEND_CAS_UPDT_DATA_HIGH:   // send second data for a multi-update (from CAS FSM)
+      case CC_SEND_CAS_UPDT_DATA_HIGH:   // send second data for multi-update (from CAS FSM)
       {
         if(not p_dspin_m2p.read) break;
@@ -7042,4 +6832,6 @@
   //////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "cc_receive_fsm" << std::endl;
+
   switch(r_cc_receive_fsm.read())
   {
@@ -7123,4 +6915,5 @@
       }
   }
+
   //////////////////////////////////////////////////////////////////////////
   //    TGT_RSP FSM
@@ -7141,4 +6934,6 @@
   //////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "tgt_rsp_fsm" << std::endl;
+
   switch(r_tgt_rsp_fsm.read())
   {
@@ -7336,5 +7131,5 @@
     }
     /////////////////////
-    case TGT_RSP_TGT_CMD: // send the response for a segmentation violation
+    case TGT_RSP_TGT_CMD: // send the response for a configuration access
     {
       if ( p_vci_tgt.rspack )
@@ -7348,8 +7143,9 @@
   std::cout
     << "  <MEMC " << name()
-    << " TGT_RSP_TGT_CMD> Segmentation violation response"
+    << " TGT_RSP_TGT_CMD> Send response for a configuration access"
     << " / rsrcid = " << std::hex << r_tgt_cmd_to_tgt_rsp_srcid.read()
     << " / rtrdid = " << r_tgt_cmd_to_tgt_rsp_trdid.read()
     << " / rpktid = " << r_tgt_cmd_to_tgt_rsp_pktid.read()
+    << " / error = " << r_tgt_cmd_to_tgt_rsp_error.read()
     << std::endl;
 }
@@ -7532,4 +7328,7 @@
   // The resource is always allocated.
   /////////////////////////////////////////////////////////////////////////////////////
+
+//std::cout << std::endl << "alloc_upt_fsm" << std::endl;
+
   switch(r_alloc_upt_fsm.read())
   {
@@ -7587,11 +7386,14 @@
   // The resource is always allocated.
   /////////////////////////////////////////////////////////////////////////////////////
+
+//std::cout << std::endl << "alloc_ivt_fsm" << std::endl;
+
   switch(r_alloc_ivt_fsm.read())
   {
-      //////////////////////////
+      /////////////////////
       case ALLOC_IVT_WRITE:            // allocated to WRITE FSM
           if (r_write_fsm.read() != WRITE_BC_IVT_LOCK)
           {
-              if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
                   r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -7602,5 +7404,5 @@
                   r_alloc_ivt_fsm = ALLOC_IVT_CAS;
               
-              else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
                   r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
